#version 430 core

in vec2 fragTextureCoords;
out vec4 FragColor;

uniform sampler2D sceneTexture;
uniform sampler2D bloomTexture;
uniform float gamma = 2.2;

void main() {             
    vec3 irradiance = texture(sceneTexture, fragTextureCoords).rgb;      
    vec3 bloomColor = texture(bloomTexture, fragTextureCoords).rgb;

    // additive blending
    irradiance += bloomColor;

	// Tone mapping
	irradiance = irradiance / (irradiance + vec3(1.0F));

	// Gamma correction
	irradiance = pow(irradiance, vec3(1.0F / gamma));

    FragColor = vec4(irradiance, 1.0);
}
