#version 430 core

in vec2 fragTextureCoords;
out vec4 FragColor;

uniform sampler2D targetTexture;
  
uniform bool isHorizontal;
uniform float[5] weights = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);

void main() {             
    vec2 texelSize = 1.0 / textureSize(targetTexture, 0);
    
    // current fragment's contribution
    vec3 result = texture(targetTexture, fragTextureCoords).rgb * weights[0];
    if (isHorizontal) {
        for(int i = 1; i < 5; i++) {
            result += texture(targetTexture, fragTextureCoords + vec2(texelSize.x * i, 0.0)).rgb * weights[i];
            result += texture(targetTexture, fragTextureCoords - vec2(texelSize.x * i, 0.0)).rgb * weights[i];
        }
    } else {
        for(int i = 1; i < 5; i++) {
            result += texture(targetTexture, fragTextureCoords + vec2(0.0, texelSize.y * i)).rgb * weights[i];
            result += texture(targetTexture, fragTextureCoords - vec2(0.0, texelSize.y * i)).rgb * weights[i];
        }
    }

    FragColor = vec4(result, 1.0);
}